class smashing.PerformanceTest
{
   var score = 0;
   var time = 0;
   var loops = 20;
   var complete = false;
   function PerformanceTest(itterations, onComplete)
   {
      var _loc1_ = this;
      if(itterations)
      {
         _loc1_.loops = itterations;
      }
      _loc1_.remainingLoops = _loc1_.loops;
      if(onComplete)
      {
         _loc1_.onComplete = onComplete;
      }
      var _loc2_ = System.capabilities.version.substr(4).split(",");
      _loc1_.flashMajorVersion = Number(_loc2_[0]);
      _loc1_.flashMinorVersion = Number(_loc2_[2]);
      _loc1_.complete = false;
      _loc1_.intervalID = setInterval(function(o)
      {
         o.test();
      }
      ,0,_loc1_);
   }
   function test()
   {
      var _loc3_ = this;
      if(_loc3_.remainingLoops <= 0)
      {
         _loc3_.finalize();
         clearInterval(_loc3_.intervalID);
      }
      else
      {
         _loc3_.remainingLoops = _loc3_.remainingLoops - 1;
         var startTime = getTimer();
         var _loc2_ = undefined;
         var _loc1_ = 0;
         while(_loc1_ < 6400)
         {
            _loc2_ = {};
            _loc1_ = _loc1_ + 1;
         }
         _loc3_.time += getTimer() - startTime;
      }
   }
   function finalize()
   {
      var _loc1_ = this;
      _loc1_.score = Math.floor(_loc1_.loops / _loc1_.time * 10000);
      if(_loc1_.flashMajorVersion >= 7)
      {
         _loc1_.log = Math.log(_loc1_.score * 0.015);
      }
      else
      {
         _loc1_.log = Math.log(_loc1_.score * 0.023);
      }
      _loc1_.processor = _loc1_.log * 1000;
      _loc1_.complete = true;
      _loc1_.onComplete(_loc1_);
   }
   function toString()
   {
      var _loc1_ = this;
      if(_loc1_.score)
      {
         return "Loops:\t" + _loc1_.loops + "\nFlash Version: \t" + System.capabilities.version + "\nTotal Time:\t" + _loc1_.time + "\nScore: \t" + _loc1_.score + "\nProcessor: \t" + _loc1_.processor;
      }
      return "Test In Process.";
   }
}
